//This program is licensed under the GPLv3; see license.txt for more info.
//Copyright 2007 Sprite_tm

#include "rtc.h"
#include "setup.h"
#include <avr/interrupt.h>

char hour;
char min;
char sec;

//This interrupt gets called 500 times a second. It handles the timekeeping
//and calls the routine responsible for the button interaction (which includes
//setting up etcetera)
ISR(TIMER0_COMPA_vect) {
    static unsigned short ticks=500;
    ticks--;
    //Every 1/4th second, call button-handling routines.
    if ((ticks&127)==0) btn_tick();
    //If no 500 ticks have passed yet, exit the subroutine.
    if (ticks!=0) return;
    
    //A second has passed.
    ticks=500;
    
    //Adjust sec/min/hour
    sec++;
    if (sec<60) return;
    sec=0; min++;
    if (min<60) return;
    min=0; hour++;
    if (hour<12) return;
    hour=0;
}

